* PROGRAM:  vstpop.prg
* FUNCTION: pop box to select state code; part of popdemo.prg
* Maurice Frank

PARAMETERS TOP_ROW, MCOL, MDISP_LINES

PRIVATE TOP_ROW, MROW, MCOL, MDISP_LINES, MWIDTH, I

MWIDTH = 26

MCODE_R = ""                        && return var
MNAME_R = ""                        && return var - indirect (caller creates it)

?? SYS(2002)
SAVE SCREEN TO vstpop

* clear screen area for box, draw box, display titles

@ TOP_ROW,MCOL TO TOP_ROW + MDISP_LINES + 3,MCOL + MWIDTH - 2 CLEAR
@ TOP_ROW,MCOL TO TOP_ROW + MDISP_LINES + 3,MCOL + MWIDTH - 2 DOUBLE
@ TOP_ROW+2,MCOL SAY CHR(204) + REPLICATE(CHR(205),MWIDTH-3) + CHR(185)

@ TOP_ROW+1,MCOL+2 SAY "ST NAME             #"

MAREA = STR(SELECT(),2)
SELECT 0
USE STATES INDEX STATES
TOP_REC = RECNO()

MPNTR_LN = 1                           && line to display pointer character
MPNTR = CHR(16)                        && pointer character (triangle pointing right)
MDISPLAY = .T.                         && loop control
MREFRESH = .T.                         && redisplay box contents
MRECNO = RECNO()                       && current record for selection

MSRCH_VAL = ""

DO WHILE MDISPLAY

   IF MREFRESH
      MROW = TOP_ROW + 3
      * clear area within box
      @ MROW,MCOL+1 CLEAR TO MROW+MDISP_LINES-1,MCOL+MWIDTH-3
      I = 1
      DO WHILE I <= MDISP_LINES .AND. .NOT. EOF()
         IF MPNTR_LN = I
            * display pointers
            @ MROW,MCOL+1 SAY MPNTR
            **@ MROW,MCOL+1 SAY " "
         ELSE
            @ MROW,MCOL+1 SAY " "
         ENDIF
         @ MROW,MCOL+2 SAY STATE
         @ MROW,MCOL+5 SAY NAME
         @ MROW,MCOL+21 SAY CODE                   && state number
         MROW = MROW + 1
         I = I + 1
         SKIP
      ENDDO
      GOTO MRECNO
      MREFRESH = .F.
   ENDIF

   KEY = STR(INKEY(0), 3, 0)

   DO CASE
      CASE KEY = " 13"
         * enter - select current record
         MCODE_R = STATE                           && return var
         MNAME_R = NAME + CODE                     && indirect return var - concatenate name and numeric code
         MDISPLAY = .F.
      CASE KEY $ " 27, 23"
         * escape, ctrl-end
         MCODE_R = SPACE(2)                        && no selection
         MNAME_R = SPACE(15)                       && no selection
         MDISPLAY = .F.
      CASE KEY $ " 24, 32"
         * down, spacebar
         skip
         if eof()
            skip -1
            mrefresh = .f.
            * no scroll; pntr same; recno same
         else
            if mpntr_ln = mdisp_lines
               * more records but last line of box
               mrecno = recno()
               mrefresh = .t.
               goto top_rec
               skip
               top_rec = recno()
               * pntr same
            else
               * not eof and not last line; skip and update pointer
               mrecno = recno()
               mrefresh = .f.
               @ top_row + 2 + mpntr_ln,mcol+1 say " "
               mpntr_ln = mpntr_ln + 1
               @ top_row + 2 + mpntr_ln,mcol+1 say mpntr
            endif mpntr_ln = mdisp_lines (bottom of box)
         endif eof() after skip
      CASE KEY = "  3"
         * pgdn
         GOTO TOP_REC
         SKIP MDISP_LINES
         IF EOF()
            SKIP -1
         ENDIF
         MREFRESH = TOP_REC # RECNO()        &&.T.
         TOP_REC = RECNO()
         MRECNO = RECNO()
         MPNTR_LN = 1
      CASE KEY = "  5"
         * up 
         if .not. bof()
            skip -1
            mrecno = recno()
            if mpntr_ln = 1
               * more records but first line of box
               mrefresh = .t.
               goto top_rec
               skip iif(bof(),0,-1)
               top_rec = recno()
               * mpntr_ln same
            else
               * not bof and not first line; skip and update pointer
               mrecno = recno()
               mrefresh = .f.
               @ top_row + 2 + mpntr_ln,mcol+1 say " "
               @ top_row + 2 + mpntr_ln,mcol+7 say " "
               mpntr_ln = mpntr_ln - 1
               @ top_row + 2 + mpntr_ln,mcol+1 say mpntr
               @ top_row + 2 + mpntr_ln,mcol+7 say mpntr
            endif mpntr_ln = 1 (top of box)
         endif
      CASE KEY $ " 18"
         * pgup
         GOTO TOP_REC
         SKIP IIF(BOF(), 0, -MDISP_LINES)
         MREFRESH = TOP_REC # RECNO()
         MRECNO = RECNO()
         TOP_REC = RECNO()
         MPNTR_LN = 1
      CASE KEY = "  1"
         * home
         GO TOP
         MREFRESH = TOP_REC # RECNO()
         MPNTR_LN = 1
         TOP_REC = RECNO()
         MRECNO = RECNO()
      CASE KEY = "  6"
         * end
         GO BOTTOM
         MRECNO = RECNO()
         SKIP (MDISP_LINES - 1) * -1
         MREFRESH = TOP_REC # RECNO()              && REFRESH IF TOP_REC CHANGED
         TOP_REC = RECNO()
         MPNTR_LN = MDISP_LINES

      case (val(key) >= 65 .and. val(key) <= 90) .or. (val(key) >= 97 .and. val(key) <= 122)
         * letters A - Z or a - z; convert lower to upper if necessary
         * doesn't handle backspace yet but it should

         mrec_save = recno()
         mchar = upper(chr(val(key)))
         @ 24,00
         ?? "Searching for: " + msrch_val + mchar
         seek msrch_val + mchar
         if found()
            msrch_val = msrch_val + mchar
            mrefresh = top_rec # recno()
            top_rec = recno()
            mrecno = recno()
            mpntr_ln = 1
         else
            goto mrec_save
            msrch_val = ""
            ?? chr(07)
         endif

      OTHERWISE
         * any other key - don't refresh or change anything
         MREFRESH = .F.

   ENDCASE

ENDDO

USE
SELECT &MAREA

RESTORE SCREEN FROM vstpop
?? SYS(2002,1)

RETURN MCODE_R

